#define GET_X_LPARAM(lParam)   ((int)(short)LOWORD(lParam))
#define GET_Y_LPARAM(lParam)   ((int)(short)HIWORD(lParam))

#ifdef __BORLANDC__
	#define _stricmp stricmp
#endif

#if DEBUG
	#pragma comment (lib, "blackbox.lib")
#else
	#pragma comment (lib, "blackbox.lib")
	#ifndef NO_AGGRESSION
//		#include <AggressiveOptimize.h>
	#endif
#endif

#include <cstdlib>
#include <ctime>
#include "BBApi.h"
//#include "C:\Documents and Settings\Tresni\My Documents\BB4Win\xoblite.h"
#include "Broambox.h"
#include <shellapi.h>

extern LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
extern LRESULT CALLBACK EditProc(HWND, UINT, WPARAM, LPARAM);
int messages[] = { BB_BROADCAST, BB_RECONFIGURE, 0 };

#define ADVICE_COUNT 20
char advice[ADVICE_COUNT][30] = {
	"Signs point to yes.",
	"Yes.",
	"Reply hazy, try again.",
	"Without a doubt.",
	"My sources say no.",
	"As I see it, yes.",
	"You may rely on it.",
	"Concentrate and ask again.",
	"Outlook not so good.",
	"It is decidedly so.",
	"Better not tell you now.",
	"Very doubtful.",
	"Yes - definitely.",
	"It is certain.",
	"Cannot predict now.",
	"Most likely.",
	"Ask again later.",
	"My reply is no.",
	"Outlook good.",
	"Don't count on it."
};

Broambox::Broambox(HINSTANCE hInstance, HWND hWnd)
{
	hMainInst = hInstance;

	hBB4Win = GetBBWnd();
	hSlit = hWnd;
	hEditWnd = NULL;

	hEditFont = NULL;

	mainStyle = NULL;
	editStyle = NULL;
	mainMenu = NULL;

	inSlit = false;
	
	tempSlit = false;
	noWho = false;
	no8Ball = false;

	historyIndex = 0;
	historyCount = 0;
	ZeroMemory(&history, sizeof(history));

	ReadSettings();
}

bool Broambox::CreateBroambox()
{
	hEditWnd = CreateWindowEx(
					WS_EX_TOOLWINDOW,
					"EDIT",
					NULL,
					WS_POPUP | WS_VISIBLE | ES_AUTOHSCROLL | ES_MULTILINE,
					x, y, width, height,
					NULL,
					NULL,
					hMainInst,
					NULL);

	wpEditProc = (WNDPROC)SetWindowLong(hEditWnd, GWL_WNDPROC,(long)EditProc);


	SendMessage(hBB4Win, BB_REGISTERMESSAGE, (WPARAM)hEditWnd, (LPARAM)messages);
	MakeSticky(hEditWnd);

	if( InSlit() )
		SendMessage(hSlit, SLIT_ADD, NULL, (LPARAM)hEditWnd);

	ReplaceFont();

	return 0;
}

void Broambox::DestroyBroambox()
{
	if(mainStyle) delete mainStyle;
	if(editStyle) delete editStyle;

	LeaveSlit();
	SendMessage(hBB4Win, BB_UNREGISTERMESSAGE, (WPARAM)hEditWnd, (LPARAM)messages);
	RemoveSticky(hEditWnd);
	
	if(hEditFont) DeleteObject(hEditFont);
	DestroyWindow(hEditWnd);

	UnregisterClass(GetAppName(), hMainInst);
}

void Broambox::MoveBroambox(WINDOWPOS* wndPos)
{
	x = wndPos->x;
	y = wndPos->y;
/*
	WriteInt(pBBTray->rcpath, "bbtray.x:", pBBTray->BBTrayX);
	WriteInt(pBBTray->rcpath, "bbtray.y:", pBBTray->BBTrayY);
*/
}

void Broambox::SizeBroambox()
{
	MoveWindow(hEditWnd, x, y, width, height, TRUE);
}
// gr
void Broambox::PaintBroambox(HDC hdc, LPRECT rp)
{
	RECT temp = *rp;
	MakeGradient(hdc, *rp, mainStyle->type, mainBackColor, mainBackColorTo, mainStyle->interlaced, mainStyle->bevelstyle, mainStyle->bevelposition, bevel, borderColor, border);

	if(!editStyle->parentRelative)
	{
		temp.bottom -= bevel + border;
		temp.top += bevel + border;
		temp.right -= bevel + border;
		temp.left += bevel + border;
		MakeGradient(hdc, temp, editStyle->type, editBackColor, editBackColorTo, editStyle->interlaced, editStyle->bevelstyle, editStyle->bevelposition, bevel, borderColor, border);
	}
}

void Broambox::ReadSettings()
{
	char path[MAX_LINE_LENGTH];
	char path2[MAX_LINE_LENGTH];
	char path3[MAX_LINE_LENGTH];
	char pathh[MAX_LINE_LENGTH], patha[MAX_LINE_LENGTH]; 
    int nLen;
    GetBlackboxPath(path, sizeof(path));
	sprintf(pathh, "%shistory.txt", path);
    sprintf(patha, "%saliases.txt", path);

	/* Load History */
    FILE *f_hist = fopen(pathh, "r");
	if(f_hist)
	{
     char histbuf[1024];
	 char *hist_read;
	 do{
         hist_read = fgets(histbuf, 1023, f_hist);
         if(hist_read)
	 		strcpy(history[historyCount++],hist_read);
	 } while(hist_read);
	
	 fclose(f_hist);
	}

	
    /* Load Aliases */
	nAli=0;
    FILE *f_ali = fopen(patha, "r");
	if(f_ali)
	{
     char alibuf[1024], *aliname, *alival;
	 char *ali_read;
	 do{
         ali_read = fgets(alibuf, 1023, f_ali);
         if(ali_read)
		 {
		    
			alival = strchr(ali_read, ' ');			
			
			if(alival)			
			{
			   *(alival++) = '\0';
			   alival[strlen(alival)-1]='\0';
			}
			   
			
			 if(alival)
             strcpy(alias_vals[nAli], alival);
			else
		     strcpy(alias_vals[nAli], "");
	
	 		strcpy(alias_names[nAli++], ali_read);			
		 }
	 } while(ali_read);
	
	 fclose(f_ali);
	}



	strcpy(path2, path);
	strcpy(path3, path);
	strcat(path2, "broamboxrc");
	strcat(path3, "broambox.rc");

	if (FileExists(path2)) strcpy(path, path2);
	else if(FileExists(path3)) strcpy(path, path3);
	else
	{
		GetModuleFileName(hMainInst, path, sizeof(path));
		nLen = strlen(path) - 1;
		while (nLen >0 && path[nLen] != '\\') nLen--;
		path[nLen + 1] = 0;

		strcpy(path2, path);
		strcpy(path3, path);
		strcat(path2, "broambox.rc");
		strcat(path3, "broamboxrc");

		if (FileExists(path3)) strcpy(path, path3);
		else strcpy(path, path2);
	}

	x = ReadInt(path, "broambox.x:", 0);
	y = ReadInt(path, "broambox.y:", 0);
	width = ReadInt(path, "broambox.width:", 300);
	inSlit = ReadBool(path, "broambox.inslit:", false);
	useAutoHide = ReadBool(path, "broambox.autohide:", true);
	noWho = ReadBool(path, "broambox.easteregg.noWho:", false);
	no8Ball = ReadBool(path, "broambox.easteregg.no8Ball:", false);
	
	// Get the path to the current style file from Blackbox...
	strcpy(path, stylePath());

	// Get the applicable color settings from the current style...
	mainBackColor = ReadColor(path, "toolbar.color:", "#000000");
	mainBackColorTo = ReadColor(path, "toolbar.colorTo:", "#FFFFFF");
	strcpy(path2, ReadString(path, "toolbar.textColor:", "#000000"));
	editBackColor = ReadColor(path, "toolbar.label.color:", "#000000");
	editBackColorTo = ReadColor(path, "toolbar.label.colorTo:", "#FFFFFF");

	textColor = ReadColor(path, "toolbar.label.textColor:", path2);

	borderColor = ReadColor(path, "borderColor:", "#000000");

	char temp[MAX_LINE_LENGTH];
	strcpy(temp, ReadString(path, "*font:", "courier new"));
	strcpy(fontFace, ReadString(path, "toolbar.font:", temp));

	fontHeight = ReadInt(path, "toolbar.fontHeight:", 12);

	// ...gradient type, bevel etc. (using a StyleItem)...
	char tempstyle[MAX_LINE_LENGTH];

	strcpy(tempstyle, ReadString(path, "toolbar:", "Flat Gradient Vertical"));
	if (mainStyle) delete mainStyle;
	mainStyle = new StyleItem;
	ParseItem(tempstyle, mainStyle);

	strcpy(tempstyle, ReadString(path, "toolbar.label:", "ParentRelative"));
	if(editStyle) delete editStyle;
	editStyle = new StyleItem;
	ParseItem(tempstyle, editStyle);

	// ...and some additional parameters
	bevel = ReadInt(path, "bevelWidth:", 0);
	border = ReadInt(path, "borderWidth:", 0);

	if (ReadBool(extensionsrcPath(), "blackbox.appearance.bullet.unix:", true))
        height = fontHeight + 2 + (2 * bevel) + (border * 4);
    else
        height = fontHeight + 2 + (border * 2);

}

void Broambox::ReplaceFont()
{
	if(hEditFont != NULL)
		DeleteObject(hEditFont);
	
	hEditFont = CreateFont(fontHeight,0,0,0,
		FW_DONTCARE, FALSE, FALSE, FALSE,
		DEFAULT_CHARSET,
		OUT_DEFAULT_PRECIS,
		CLIP_DEFAULT_PRECIS,
		ANTIALIASED_QUALITY,
		0, fontFace);
	
	SendMessage(hEditWnd, WM_SETFONT, (WPARAM)hEditFont, FALSE);

	//gr - Text Centering in Box
	TEXTMETRIC TXM;
	HDC hdc = CreateCompatibleDC(NULL);
	SelectObject(hdc, hEditFont);
	GetTextMetrics(hdc, &TXM);
	DeleteDC(hdc);

	int realfontheight = TXM.tmHeight; //pixel

	RECT r;
	GetClientRect(hEditWnd, &r);

	int extraspace = (r.bottom - realfontheight) / 2;
	if (extraspace<0) extraspace=0;

	r.left      = extraspace+1;
	r.right     -= extraspace+1;
	r.top       = extraspace;
	r.bottom    -= extraspace;

	SendMessage(hEditWnd, EM_SETRECT, 0, (LPARAM)&r);
}
void Broambox::ExpandAlias(char *ret_val, char *alias_val, char *remaining, char *args)
{
  char *arg;
  char tmp[MAX_LINE_LENGTH];

  arg = strstr(alias_val, "<args>");
  if(arg)
  {
    *(arg)='\0';
	arg+=6;
    strcpy(ret_val, alias_val);
    strcat(ret_val, remaining);
	strcat(ret_val, arg);
  }
  else
  {
   strcpy(tmp, alias_val);
   char *remg = strchr(tmp, ' ');			
   if(remg)
   {
     *(remg++) = '\0';
	  strcpy(ret_val, tmp);
	  strcpy(args, remg);
	  if(remaining)
	    strcat(args, remaining);
   }
   else
	 strcpy(ret_val, alias_val);

   
  }
}
void Broambox::ExpandAliases(char *buf, char *args)
{
		    
char *firstword;
char *remaining;
int found_match = 0;
remaining = strchr(buf, ' ');			
if(remaining)
   *(remaining++) = '\0';
firstword=buf;
	
char ret_val[MAX_LINE_LENGTH];
strcpy(ret_val, buf);
if(remaining)
  strcpy(args, remaining);
else
 strcpy(args, "");

if(firstword)
{

if(firstword[0]=='?')
{
 int remln = strlen(remaining);
  /* Fix for search engines */
  for(int j=0;j<remln;j++)
  {
    if(remaining[j]==' ')
		remaining[j]='+';
  } 
}

  for(int i=0;i<nAli;i++)
  {
    if(alias_names[i] && alias_vals[i])
	{
		
	 if(!(_stricmp(firstword, alias_names[i])))
	 {
        ExpandAlias(ret_val, alias_vals[i], remaining, args);
	    
		found_match = 1;
		break;
	 }
	}

 if(!found_match && firstword[0]=='?')
 {
  strcpy(ret_val, "http://www.google.com/search?q=");
  strcat(ret_val, remaining);
 }


  }

}
  
  strcpy(buf, ret_val);

}

void Broambox::Execute()
{
	char buf[MAX_LINE_LENGTH], args[MAX_LINE_LENGTH];
	
	GetWindowText(hEditWnd,buf,sizeof(buf));
	ExpandAliases(buf, args);

  
	if(buf[0] == '@')
		PostMessage(hBB4Win, BB_BROADCAST, 0, (LPARAM)buf);
	else if(buf[0] == '[' && buf[strlen(buf) - 1] == ']')
	{
		if(!_stricmp(buf,"[exit]") || !_stricmp(buf, "[quit]"))
			PostMessage(hBB4Win, BB_QUIT, 0, 0);
		else if(!_stricmp(buf,"[shutdown]"))
			PostMessage(hBB4Win, BB_SHUTDOWN, 0, 0);
		else if(!_stricmp(buf,"[reboot]"))
			PostMessage(hBB4Win, BB_SHUTDOWN, 1, 0);
		else if(!_stricmp(buf,"[logoff]"))
			PostMessage(hBB4Win, BB_SHUTDOWN, 2, 0);
		else if(!_stricmp(buf,"[hibernate]"))
			PostMessage(hBB4Win, BB_SHUTDOWN, 3, 0);
		else if(!_stricmp(buf,"[suspend]"))
			PostMessage(hBB4Win, BB_SHUTDOWN, 4, 0);
		else if(!_stricmp(buf,"[lock]"))
			PostMessage(hBB4Win, BB_SHUTDOWN, 5, 0);
		else if(!_stricmp(buf,"[run]"))
			PostMessage(hBB4Win, BB_RUN, 0, 0);
		else if(!_stricmp(buf,"[reconfig]"))
			PostMessage(hBB4Win, BB_RECONFIGURE, 0, 0);
		else if(!_stricmp(buf,"[restart]"))
			PostMessage(hBB4Win, BB_RESTART, 0, 0);
		else if(!_stricmp(buf,"[editstyle]"))
			PostMessage(hBB4Win, BB_EDITFILE, 0, 0);
		else if(!_stricmp(buf,"[editmenu]"))
			PostMessage(hBB4Win, BB_EDITFILE, 1, 0);
		else if(!_stricmp(buf,"[editplugins]"))
			PostMessage(hBB4Win, BB_EDITFILE, 2, 0);
		else if(!_stricmp(buf,"[editextensions]"))
			PostMessage(hBB4Win, BB_EDITFILE, 3, 0);
		else if(!_strnicmp(buf, "[who", 4) && !noWho)
		{
			char temp[50];
			DWORD len = 50;
			GetUserName(temp, &len);
			temp[len] = '\0';
			
			SetWindowText(hEditWnd, temp);
			SetFocus(NULL);
			goto copy_to_history;
		}
	}
	else
		ShellExecute(NULL, NULL, buf, args, NULL, SW_SHOWNORMAL);

	SetWindowText(hEditWnd,"");

copy_to_history:
	for(int i = historyCount - 1; i >= 0; i--)
		strcpy(history[i + 1], history[i]);
	
	strcpy(history[0], buf);
	if(historyCount < HIST_SIZE)
		historyCount++;
	FILE *f_hist = fopen("history.txt", "a");
	if(!f_hist)
		fopen("history.txt", "w");
	if(f_hist)
	{
	 fprintf(f_hist, "%s\n", buf);
	 fflush(f_hist);
	 fclose(f_hist);
	}
}

void Broambox::ShowWindow()
{
	if(!InSlit())
		ShowWindowAt(x, y);
}

void Broambox::ShowWindowAt(int x, int y)
{
	if(InSlit())
	{
		tempSlit = true;
		LeaveSlit();
	}
	SetWindowPos(hEditWnd, HWND_TOP, x, y, 0, 0, SWP_NOSENDCHANGING | SWP_NOSIZE | SWP_SHOWWINDOW);
}

void Broambox::HideWindow()
{
	if(tempSlit && hSlit != NULL)
	{
		EnterSlit();
		tempSlit = false;
	}
	else if(!InSlit())
		SetWindowPos(hEditWnd, NULL, x, y, 0, 0, SWP_NOZORDER | SWP_NOSENDCHANGING | SWP_NOSIZE | SWP_HIDEWINDOW);
}

void Broambox::EnterSlit()
{
	if( !InSlit() )
	{
		SendMessage(hSlit, SLIT_ADD, NULL, (LPARAM)hEditWnd);
		//SizeBroambox();
		inSlit = true;
	}
}

void Broambox::LeaveSlit()
{
	if( InSlit() )
	{
		SendMessage(hSlit, SLIT_REMOVE, NULL, (LPARAM)hEditWnd);
		//SizeBroambox();
		inSlit = false;
	}
}

void Broambox::UpdateSlit()
{
	if(InSlit())
		SendMessage(hSlit, SLIT_UPDATE, NULL, NULL);
}

void Broambox::ToggleSlitAutoHide(bool getSetting)
{
	if(InSlit())
	{
		if(getSetting)
			isSlitAutoHide = ReadBool(bbrcPath(), "session.screen0.slit.autohide:", false);
		
		if(isSlitAutoHide && getSetting)
			SendMessage(hBB4Win, BB_BROADCAST, NULL, (LPARAM)"@BBSlit Toggle Hide Off");
		else if(isSlitAutoHide)
		{
			SendMessage(hBB4Win, BB_BROADCAST, NULL, (LPARAM)"@BBSlit Toggle Hide On");
			isSlitAutoHide = false;
		}
	}
}

void Broambox::AutoComplete(char *cur)
{
	for(int i=0;i<historyCount;i++)
	{
		if(strstr(history[i],cur)==history[i])
			SetWindowText(hEditWnd, history[i]);


	}
	
	SendMessage(hEditWnd, EM_SETSEL, 0, -1);
	SendMessage(hEditWnd, EM_SETSEL, -1, 0);
}


void Broambox::HistoryNext()
{
	char* szBuf;

	if(historyIndex >= historyCount)
	{
		szBuf = history[historyCount - 1];
		historyIndex = historyCount;
	}
	else
		szBuf = history[historyIndex++];

	SetWindowText(hEditWnd, szBuf);
	
	SendMessage(hEditWnd, EM_SETSEL, 0, -1);
	SendMessage(hEditWnd, EM_SETSEL, -1, 0);
}

void Broambox::HistoryPrev()
{
	char* szBuf;

	if(historyIndex <= 0)
	{
		szBuf = "";
		historyIndex = 0;
	}
	else {
		if(historyIndex != 1)
			szBuf = history[historyIndex-2];
		else
			szBuf = "";
		historyIndex--;
	}

	SetWindowText(hEditWnd, szBuf);

	SendMessage(hEditWnd, EM_SETSEL, 0, -1);
	SendMessage(hEditWnd, EM_SETSEL, -1, 0);
}

LRESULT Broambox::RButtonDown(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	if((GetAsyncKeyState(VK_CONTROL) & 0x8000) && hSlit)
	{
		if(mainMenu)
			DelMenu(mainMenu);

		mainMenu = MakeMenu("bro@mbox");

		MakeMenuItem(mainMenu, "In Slit", "@Broambox Toggle Slit", InSlit());

		ShowMenu(mainMenu);

		return 0;
	}
	else
		return CallWindowProc(wpEditProc,hWnd,uMsg,wParam,lParam);;
}
